/*
 Copyright 2015 Nicolas Melot

 This file is part of Drake-FFT2_streaming.

 Drake-FFT2_streaming is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Drake-FFT2_streaming is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Drake-FFT2_streaming. If not, see <http://www.gnu.org/licenses/>.

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "args.h"

app_args_t parse_args(args_t *arg)
{
	args_t args = *arg;
	app_args_t app_args;

	// Default values
	app_args.n = 1;
	app_args.rounds = 1;
	app_args.time = 0;

	for(; args.argv[0] != NULL; args.argv++)
	{
		if(strcmp(args.argv[0], "--work-unit") == 0)
		{
			args.argv++;
			app_args.n = atoi(args.argv[0]);
			continue;
		}
		if(strcmp(args.argv[0], "--rounds") == 0)
		{
			args.argv++;
			app_args.rounds = atoi(args.argv[0]);
			continue;
		}
		if(strcmp(args.argv[0], "--time") == 0)
		{
			args.argv++;
			app_args.time = atof(args.argv[0]);
			continue;
		}		
	}

	return app_args;
}

