/*
 Copyright 2015 Nicolas Melot

 This file is part of Drake-FFT2_streaming.

 Drake-FFT2_streaming is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Drake-FFT2_streaming is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Drake-FFT2_streaming. If not, see <http://www.gnu.org/licenses/>.

*/


#include <stdlib.h>
#include <math.h>
#include <string.h>

#include <pelib/float.h>
#include <drake/schedule.h>
#include <drake/node.h>
#include <drake/link.h>
#include <drake/platform.h>
#include <drake/eval.h>
#include <math.h>

#include "args.h"

int drake_init(task_t *task, void *arg)
{
	return 1;
}

int drake_start(task_t *task)
{
	return 1;
}

static int numel = 0;
int
drake_run(task_t *task)
{
	link_t *in = pelib_map_read(string, link_tp)(pelib_map_find(string, link_tp)(task->pred, "input")).value;
	int num = pelib_cfifo_length(float)(((cfifo_t(float)*)in->buffer));

	while(num >= 2)
	{
		float val_r, val_i;
		val_r = pelib_cfifo_pop(float)(((cfifo_t(float)*)in->buffer));
		val_i = pelib_cfifo_pop(float)(((cfifo_t(float)*)in->buffer));
		numel += 1;
		// Same output format as Streamit's FFT2 program; allows direct output comparison using diff
		//printf("%f\n%f\n", val_r, val_i);
		num -= 2;
	}

	int killed = ((in->prod == NULL) ? 1 : in->prod->status >= TASK_KILLED);
	int empty = pelib_cfifo_length(float)(((cfifo_t(float)*)in->buffer)) == 0;

	if(killed && empty)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

int
drake_kill(task_t *task)
{
	/* Do nothing */
	return 0;
}

int
drake_destroy(task_t *task)
{
	//printf("Numel produced: %i\n", numel);
	return 0;
}
